Option Explicit On 
Option Strict On
Option Compare Binary

Imports System
Imports System.IO

' <remarks>
'   Stellt den Einsprungspunkt der Anwendung bereit.
' </remarks>
Public Class Main
    Private Shared m_Enumerator As FileSystemEnumerator

    ' <summary>
    '   Der Einsprungspunkt der Anwendung.
    ' </summary>
    Public Shared Sub Main()
        Dim m_Enumerator As FileSystemEnumerator = New FileSystemEnumerator()
        m_Enumerator.StartDirectory = New DirectoryInfo("C:\")
        AddHandler m_Enumerator.DirectoryFound, _
          AddressOf Enumerator_DirectoryFound
        AddHandler m_Enumerator.FileFound, _
          AddressOf Enumerator_FileFound
        Console.WriteLine("Suche Dateien mit Endung " & _
          ".exe in ""C:\"", die nicht in ""C:\WINDOWS"" liegen...")
        m_Enumerator.Enumerate()
        RemoveHandler m_Enumerator.DirectoryFound, _
          AddressOf Enumerator_DirectoryFound
        RemoveHandler m_Enumerator.FileFound, _
          AddressOf Enumerator_FileFound
    End Sub

    Private Shared Sub Enumerator_DirectoryFound( _
      ByVal Directory As DirectoryInfo, _
      ByRef ContinueRecursion As Boolean)
        ContinueRecursion = (Directory.FullName <> "C:\WINDOWS")
    End Sub

    Private Shared Sub Enumerator_FileFound( _
      ByVal File As System.IO.FileInfo)
        Try
            If File.Extension = ".exe" Then
                Console.WriteLine(File.FullName)
                Console.Out.Flush()
            End If
        Catch
        End Try
    End Sub
End Class

